ALTER TABLE CFG_Server
    ADD ResetMemberAfterRejoin BOOLEAN NOT NULL DEFAULT FALSE AFTER GameOfferNotificationChatId;



ALTER TABLE CFG_ServerHistory
    ADD ResetMemberAfterRejoin BOOLEAN NOT NULL DEFAULT FALSE AFTER GameOfferNotificationChatId;

DROP TRIGGER IF EXISTS `TR_CFG_ServerUpdate`;;

CREATE TRIGGER `TR_CFG_ServerUpdate`
    AFTER UPDATE
    ON `CFG_Server`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerHistory` (`Id`,
                                     `MessageDeleteTimer`,
                                     `NotificationChatId`,
                                     `MaxVoiceStateHours`,
                                     `XpPerMessage`,
                                     `XpPerReaction`,
                                     `MaxMessageXpPerHour`,
                                     `XpPerOntimeHour`,
                                     `XpPerEventParticipation`,
                                     `XpPerAchievement`,
                                     `AFKCommandChannelId`,
                                     `HelpVoiceChannelId`,
                                     `TeamChannelId`,
                                     `LoginMessageChannelId`,
                                     `DefaultRoleId`,
                                     `ShortRoleNameSetOnlyHighest`,
                                     `GameOfferNotificationChatId`,
                                     `ResetMemberAfterRejoin`,
                                     `FeatureFlags`,
                                     `ServerId`,
                                     `DateFrom`,
                                     `DateTo`)
    VALUES (OLD.Id,
            OLD.MessageDeleteTimer,
            OLD.NotificationChatId,
            OLD.MaxVoiceStateHours,
            OLD.XpPerMessage,
            OLD.XpPerReaction,
            OLD.MaxMessageXpPerHour,
            OLD.XpPerOntimeHour,
            OLD.XpPerEventParticipation,
            OLD.XpPerAchievement,
            OLD.AFKCommandChannelId,
            OLD.HelpVoiceChannelId,
            OLD.TeamChannelId,
            OLD.LoginMessageChannelId,
            OLD.DefaultRoleId,
            OLD.ShortRoleNameSetOnlyHighest,
            OLD.GameOfferNotificationChatId,
            OLD.ResetMemberAfterRejoin,
            OLD.FeatureFlags,
            OLD.ServerId,
            OLD.LastModifiedAt,
            CURRENT_TIMESTAMP(6));
END;;

DROP TRIGGER IF EXISTS `TR_CFG_ServerDelete`;;

CREATE TRIGGER `TR_CFG_ServerDelete`
    AFTER DELETE
    ON `CFG_Server`
    FOR EACH ROW
BEGIN
    INSERT INTO `CFG_ServerHistory` (`Id`,
                                     `MessageDeleteTimer`,
                                     `NotificationChatId`,
                                     `MaxVoiceStateHours`,
                                     `XpPerMessage`,
                                     `XpPerReaction`,
                                     `MaxMessageXpPerHour`,
                                     `XpPerOntimeHour`,
                                     `XpPerEventParticipation`,
                                     `XpPerAchievement`,
                                     `AFKCommandChannelId`,
                                     `HelpVoiceChannelId`,
                                     `TeamChannelId`,
                                     `LoginMessageChannelId`,
                                     `DefaultRoleId`,
                                     `ShortRoleNameSetOnlyHighest`,
                                     `GameOfferNotificationChatId`,
                                     `ResetMemberAfterRejoin`,
                                     `ServerId`,
                                     `FeatureFlags`,
                                     `Deleted`,
                                     `DateFrom`,
                                     `DateTo`)
    VALUES (OLD.Id,
            OLD.MessageDeleteTimer,
            OLD.NotificationChatId,
            OLD.MaxVoiceStateHours,
            OLD.XpPerMessage,
            OLD.XpPerReaction,
            OLD.MaxMessageXpPerHour,
            OLD.XpPerOntimeHour,
            OLD.XpPerEventParticipation,
            OLD.XpPerAchievement,
            OLD.AFKCommandChannelId,
            OLD.HelpVoiceChannelId,
            OLD.TeamChannelId,
            OLD.LoginMessageChannelId,
            OLD.DefaultRoleId,
            OLD.ShortRoleNameSetOnlyHighest,
            OLD.GameOfferNotificationChatId,
            OLD.ResetMemberAfterRejoin,
            OLD.FeatureFlags,
            OLD.ServerId,
            TRUE,
            OLD.LastModifiedAt,
            CURRENT_TIMESTAMP(6));
END;;

