from datetime import datetime

from cpl_core.application.application_extension_abc import ApplicationExtensionABC
from cpl_core.configuration import ConfigurationABC
from cpl_core.dependency_injection import ServiceProviderABC

from migration_to_sql.mock.migration_service import MigrationService


class DatabaseExtension(ApplicationExtensionABC):
    def __init__(self):
        pass

    async def run(self, config: ConfigurationABC, services: ServiceProviderABC):
        config.add_configuration("Database_StartTime", str(datetime.now()))
        migrations: MigrationService = services.get_service(MigrationService)
        migrations.migrate()
